import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.media.*;
import javax.media.protocol.*;
import java.net.*;
//import idv.project.myjava.jmpused.MediaFilter ;

/**
 *  This class provide gui and player method for project JMP.
 *  @see javax.meida.manager
 *  @author 8942007 ; 8942018 ; 8942032 ;  Java Programing FINAL PROJECT : Java Media Player
 *
 *  Addition note that for safety purpose , filefilter was suspended ( Line 10 ; Line 487 )
 *  for the reason that it need package to self-builded classes
 *  and depend on enviroment settings
 */

public class JavaMediaPlayer extends JFrame
{
	// globe used variable init
	final static int width = 400 , height = 260 ;
	int setLoop = 1 ;
	int currentTrack = -1 ;
	String location ;
	Dimension dim = new Dimension( 60 , 25 )
		, dim2 = new Dimension( 200 , 25 ) ;

    Player defaultPlayer , player = null;
 	JList playHistory ;
 	DefaultListModel listData ;
	JPanel thePanel;
	JTextField nowPlay ;
	JToolBar toolBar , toolBar2 ;
	JButton foward , back , play , delete
		, visible , invisible , openLibrary ;
	JSlider volumeSlider ;
	JScrollPane listScrollPane ;
	JRadioButtonMenuItem loopChoices[];

	GridBagLayout gbLayout ;
	GridBagConstraints gbConstraints;
	Container jmpContainer , southBorder , northBorder , centerBorder ;

	/**
	 *  Constructor of jmp init each var needed and create GUI also
	 *  Mnemonic Key(Alt + )  :  1. Play = p
	 *                                            2. Next Track = n
	 *                                            3. Previous Track = f
	 *                                            4. Delete Track from List = d
	 */
	public JavaMediaPlayer ()
	{
		super("Java Media Player");

    	String loopChoiceNames[] = { "Loop All" , "Loop One" , "Normal" };
    	JLabel label1 ;
    	ImageIcon del = new ImageIcon( "delete.gif");
    	ImageIcon hide = new ImageIcon( "hide.gif" );
    	ImageIcon show = new ImageIcon( "show.gif" );
    	ImageIcon icon = new ImageIcon("play.gif");
    	ImageIcon icon1 = new ImageIcon("back.gif");
    	ImageIcon icon2 = new ImageIcon("foward.gif");
    	ImageIcon library = new ImageIcon( "library3.gif" );
    	JMenuBar bar ;
    	JMenu fileMenu , optionMenu , loopMenu;
    	JMenuItem openFile , exitItem ,openURL ;
    	ButtonGroup loopGroup ;

		// initialized component
        jmpContainer = getContentPane();
        jmpContainer.setLayout(new BorderLayout() );
        southBorder = new Container () ;
        southBorder.setLayout ( new BorderLayout() );
        northBorder = new Container () ;
        northBorder.setLayout ( new BorderLayout() );
        centerBorder = new Container ();
        centerBorder.setLayout( new BorderLayout() );
        thePanel = new JPanel();
        gbLayout = new GridBagLayout() ;
        thePanel.setLayout( gbLayout );
        gbConstraints = new GridBagConstraints ();
        gbConstraints.fill = GridBagConstraints.HORIZONTAL;


        // event handlers
        ButtonHandler buttonHandler = new ButtonHandler () ;  //done
        ListHandler listHandler = new ListHandler () ;   //done
        ListClickHandler listClickHandler = new ListClickHandler() ; //
        MenuHandler menuHandler = new MenuHandler () ;      //done
        OptionHandler optionHandler = new OptionHandler() ;   //done
        VolumeHandler volumeHandler = new VolumeHandler() ; //done

		// build GUI items
        play = new JButton (  icon );
        play.setToolTipText( "Play Selected Track" );
        play.setMnemonic( 'p' );
        back = new JButton (  icon1 );
        back.setToolTipText( "Next Track" );
        back.setMnemonic( 'n' );
        foward = new JButton ( icon2 );
        foward.setToolTipText( "Previons Track" );
        foward.setMnemonic( 'f' );
        delete = new JButton ( del );
        delete.setToolTipText ( "Delete a Track from playlist" );
        delete.setMnemonic( 'd' );
        visible = new JButton ( show );
        visible.setToolTipText ( "Set playlist visible" );
        invisible = new JButton ( hide );
        invisible.setToolTipText ( "Set playlist invisible" );
        openLibrary = new JButton( library );
        openLibrary.setToolTipText( "Open my Musics" );
        openLibrary.setBorderPainted( true );
        play.setEnabled( false );
        play.setBorderPainted( true );
   		back.setEnabled( false );
		back.setBorderPainted( true );
		foward.setEnabled( false );
		foward.setBorderPainted( true );

		// volume control component
        volumeSlider = new JSlider ( JSlider.HORIZONTAL , 0 , 100 , 50);
        volumeSlider.setMajorTickSpacing ( 20 );
        volumeSlider.setMinorTickSpacing ( 10 );
        volumeSlider.setExtent ( 5 );
        volumeSlider.setPaintTicks ( true );

		// playlist control component
		listData = new DefaultListModel() ;
        playHistory = new JList( listData );
        playHistory.setVisibleRowCount( 4 );
        playHistory.setToolTipText ( " -- None -- " );
        playHistory.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        listScrollPane = new JScrollPane( playHistory );
        toolBar= new JToolBar ( "PlayList" );
        toolBar.setOrientation(JToolBar.HORIZONTAL);
        toolBar2= new JToolBar ( "PlayTool" );
        toolBar.setOrientation(JToolBar.HORIZONTAL);

        delete.addActionListener( buttonHandler );
		delete.setBorderPainted( false );
        toolBar.add(delete);
        toolBar.addSeparator();

		invisible.addActionListener( buttonHandler );
		invisible.setBorderPainted( false );
        toolBar.add(invisible);
		toolBar.addSeparator();

        visible.addActionListener( buttonHandler );
		visible.setBorderPainted( false );
		toolBar.add(visible);
		toolBar.addSeparator( dim2 );
		openLibrary.addActionListener( buttonHandler );
		toolBar.add( openLibrary );


		toolBar2.add(back);
		toolBar2.addSeparator();
		toolBar2.add(play);
		toolBar2.addSeparator();
		toolBar2.add(foward);
		toolBar2.addSeparator( dim );
		toolBar2.add(volumeSlider);
		toolBar2.setSize( 400 , 25 );

        // play track info area
        label1 = new JLabel ( "NowPlaying:" ) ;
        nowPlay = new JTextField ( 20 ) ;
        nowPlay.setEditable(false);
        nowPlay.setSize ( width/4*3 , 80 );

        bar = new JMenuBar();
		setJMenuBar(bar);
		fileMenu = new JMenu("File");
		openFile=new JMenuItem("Open");
		fileMenu.add(openFile);
		openURL = new JMenuItem ( "Open URL" );
		fileMenu.add ( openURL );
		exitItem=new JMenuItem("Exit");
		fileMenu.add(exitItem);
        optionMenu = new JMenu("Options");
        loopMenu = new JMenu("LoopSet");
        loopChoices = new JRadioButtonMenuItem[loopChoiceNames.length];
        loopGroup = new ButtonGroup();

        for (int i = 0 ; i < loopChoiceNames.length ; i++)
        {
			loopChoices[i] = new JRadioButtonMenuItem( loopChoiceNames[i] );
			loopMenu.add( loopChoices[i] );
			loopGroup.add ( loopChoices[i] );
			loopChoices[i].addActionListener ( optionHandler );
		}
		loopChoices[0].setSelected( true );
		optionMenu.add ( loopMenu );


        // add handler
        play.addActionListener ( buttonHandler );
        back.addActionListener( buttonHandler );
        foward.addActionListener( buttonHandler );

        playHistory.addListSelectionListener ( listHandler ) ;
		playHistory.addMouseListener( listClickHandler );
		openFile.addActionListener ( menuHandler ) ;
		exitItem.addActionListener ( menuHandler ) ;
		openURL.addActionListener ( menuHandler );
		volumeSlider.addChangeListener ( volumeHandler );


		bar.add(fileMenu);
        bar.add(optionMenu);

		// add each component
		addComponent( label1 , 3 , 0 , 1 , 1 , 1 , 0);
        addComponent( nowPlay , 3 , 1 , GridBagConstraints.REMAINDER , 1 , 1 , 0);

        centerBorder.add( "South" , toolBar2 );
        centerBorder.add( "Center" , thePanel );
        northBorder.add( "Center" , listScrollPane );
        northBorder.add( "North" , toolBar );
		jmpContainer.add( "Center" , centerBorder );
        jmpContainer.add( "North" , northBorder );
     	jmpContainer.add( "South" , southBorder );

		setSize( width , height  );
		setLocation( 150 , 100 );
		show();

	} // end of Constructer


	/**
	 *   Listen to action for buttons to control play track & playlist
	 */
    private class ButtonHandler implements ActionListener
    {
		public void actionPerformed ( ActionEvent event )
		{
			int  current = playHistory.getSelectedIndex() , total = listData.getSize()-1;
			String temp ;

			// deal button of toolbar2 ( nowplay info side )
			if ( total != -1 )
			{
				if ( event.getSource() == foward )
				{
					if ( current != 0 )
						qscript( --current );
					else
					{
						if ( setLoop != 1)
						{
							qscript( 0 );
						}
						else
						{
							qscript( total );
						}
					}
				}
				else if ( event.getSource() == back )
				{
					if ( current != total )
						qscript( ++current );
					else
					{
						if ( setLoop != 1 )
						{
							qscript( current );
						}
						else
						{
							qscript( 0 );
						}
					}
				}
				else if ( event.getSource() == play )
				{
					qscript( current );
				}
			}

			// deal button of toolbar1 ( playlist side )
			if ( event.getSource() == delete )
				deleteTrack();
			else if ( event.getSource() == invisible )
			{
				listScrollPane.setVisible( false );
				northBorder.validate();
			}
			else if ( event.getSource() == visible )
			{
				listScrollPane.setVisible( true );
				northBorder.validate();
			}
			else if ( event.getSource() == openLibrary )
				openFiles();
		}
	}

	/**
	 *   Menu actions
	 */
    private class MenuHandler implements ActionListener
	{
		public void actionPerformed ( ActionEvent event )
		{
			if ( event.getActionCommand() == "Open" )
				openFiles();
			else if ( event.getActionCommand() == "Exit" )
			{
				if ( player != null)
					player.close();
				System.exit(0);
			}
			else if ( event.getActionCommand() == "Open URL" )
			{
				openURL();
			}
		}
	}


	// set loopsetting
	private class OptionHandler implements ActionListener
	{
		public void actionPerformed ( ActionEvent event )
		{
			if ( loopChoices[0].isSelected() )
			    setLoop = 1;
			else if ( loopChoices[1].isSelected() )
			    setLoop = 2;
			else if ( loopChoices[2].isSelected() )
				setLoop = 3;
		}
	}

	// deal Volume ( setLevel ver.)
	private class VolumeHandler implements ChangeListener
	{
		public void stateChanged ( ChangeEvent event )
		{
			if ( player != null )
			{
			    float volume = (float) ( ((volumeSlider.getValue()) / 100.0 ) );
			    player.getGainControl().setLevel ( volume );
			}
		}
	}

	// deal component add in GridBagLayout
    private void addComponent ( Component comp , int row , int column ,
        int width , int height  , int weightx , int weighty )
    {
		gbConstraints.gridx = column ;
		gbConstraints.gridy = row ;

		gbConstraints.gridwidth = width ;
		gbConstraints.gridheight = height ;

		gbConstraints.weightx = weightx ;
		gbConstraints.weighty = weighty ;

		gbLayout.setConstraints ( comp , gbConstraints ) ;
		thePanel.add ( comp ) ;
	}

	// control while list selection was made ( Notation : the same item be seleted will be ignore )
	private class ListHandler implements ListSelectionListener
	{
		public void valueChanged(ListSelectionEvent event)
		{
			if ( listData.getSize() != 0 )
			{
				play.setEnabled( true );
				back.setEnabled( true );
				foward.setEnabled( true );
			}
		}
	}

	/**
	 *   Deal mouseclick on list ( doudle click for play , single to select )
	 *   Add Double click event for PlayList
	 *   note : db click : setSelect and play
	 *             else setSelect
	 */
	private class ListClickHandler implements MouseListener
	{
		public void mousePressed( MouseEvent e )
		{

		}
		public void mouseReleased( MouseEvent e )
		{

		}
		public void mouseEntered(MouseEvent e)
		{
		}
		public void mouseExited(MouseEvent e)
		{
	    }
	    public void mouseClicked ( MouseEvent event )
		{
			if ( event.getClickCount() == 2 )
			{
				if ( ( listData.getSize() != 0 ) )
					qscript( playHistory.getSelectedIndex() );
			}
		}
	}

	/**
	 *   Delete Track from playlist
	 *   while target track == playing track  , Stop playing ;
	 *   else won't interept player
	 */
	public void deleteTrack()
	{
		int index = playHistory.getSelectedIndex();
		int size = listData.getSize();
		if ( size != 0 )
		{
			listData.removeElementAt(index);
			size = listData.getSize();
			playHistory.setModel( listData);

			if ( currentTrack == index )
			{
				stopPlayer();
				nowPlay.setText("");
			}
			//No one's left, disable button.
			if (size == 0)
			{
				player= null ;
				play.setEnabled( false );
				back.setEnabled( false );
				foward.setEnabled( false );
				playHistory.setToolTipText( " -- None -- " );
				currentTrack = -1 ;
			}
			else
			{
				if ( currentTrack == index )
				{
					if ( index == listData.getSize())
						index--;
					playHistory.setSelectedIndex(index);
					currentTrack = index;
				}
				else
				{
					if ( currentTrack > index )
						currentTrack -- ;
					if ( index == listData.getSize())
						index--;
					playHistory.setSelectedIndex(index);
				}
			}
		}
	}

	/**
	 *  easy Script only for dupelicate job : setSelectedIndex of PlayList
	 *  and play that track
	 */
	public void qscript ( int index )
	{
		currentTrack = index ;
		playHistory.setSelectedIndex ( index );
		play ( listData.get( index ).toString() );
	}


	/**
	 *   Open music files
	 *   and used for temp music lib
	 *   enable mutiple selection ( Max selected 30 items )
	 */
	private void openFiles()
	{
		int capacity = 30 ;
		JFileChooser fileChooser=new JFileChooser();
        //fileChooser.addChoosableFileFilter(new MediaFilter());
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        fileChooser.setMultiSelectionEnabled( true );
		File temp[ ] = new File [ capacity ];

		int result= fileChooser.showDialog(this , "Add to PlayList" );

		if ( result==JFileChooser.CANCEL_OPTION )
		   	temp = null;
		else
	    {
			temp = fileChooser.getSelectedFiles();
			for ( int i = 0 ; i < temp.length ; i++ )
			{
				listData.addElement ( temp[ i ].getPath() );
			}
			if ( player == null )
				qscript( listData.getSize()-1 );
		}
	}

	/**
	 *    Count which to play next (If Loop)
	 *    For which loop set 	1 : loop all track  ( while end of last track jump to first )
	 *                                 	2 : loop this track
	 *										3 : no loop
	 */
	public void dealTrack ( int index )
	{
		int current = playHistory.getSelectedIndex() , size = listData.getSize() ;

		switch ( setLoop ) {
			case 1:
				if ( current!= -1 )
				{
					if ( size == 1 )
					{
						qscript ( current );
						break;
					}
					else if ( current < size-1 )
						current ++;
					else if ( current == size-1 )
						current = 0;
					qscript ( current );
					break;
				}
			case 2:
				if ( current != -1 )
					qscript ( current );
				break;
			default :
		}
    }


	/**
	 *   Set info of playing Track
	 *   Create player and play ( file ver )
	 */
	public void play ( String path )
	{
        if (player!=null)
		{
			stopPlayer () ;
	    }
		try
		{
			File temp = new File ( path );
			playHistory.setToolTipText ( temp.getPath() );
			nowPlay.setText ( temp.getName () ) ;
			DataSource playNow = Manager.createDataSource( temp.toURL() );
    	    player = Manager.createPlayer ( playNow ) ;
    		player.addControllerListener ( new playerController( ) );
			player.start();
	    }
	    catch ( Exception event )
	    {
			if ( event instanceof IOException)
				JOptionPane.showMessageDialog
					(this,"Error Connect Source","Error loading file",JOptionPane.ERROR_MESSAGE);
			else
				JOptionPane.showMessageDialog
				    (this,"Invalid file or location","Error loading file",JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	 *  Open a URL to play ( use dialog )
	 */
	public void openURL ()
	{
		location = (String) JOptionPane.showInputDialog
		( null , "URL : " , "Open URL" , JOptionPane.QUESTION_MESSAGE );
		if ( location != null )
			playURL ( location );
	}

	/**
	 *   Play and deal URL propoties
	 *   @param path A URL object which indicate to file in remote wed disk
	 */
	public void playURL ( String path )
	{
		if (player!=null)
		{
			stopPlayer () ;
		}

		try
		{
			URL temp = new URL( path );
			nowPlay.setText ( "URL : " + temp.getPath() ) ;
			System.err.println(temp.getQuery()+"[]"+temp.getProtocol()+"[]"+temp.getPort());
			DataSource playNow = Manager.createDataSource( temp );
			player = Manager.createPlayer ( playNow ) ;
			player.addControllerListener ( new playURLController( ) );
			player.start();
		}
		catch ( Exception event )
		{
			if ( event instanceof IOException)
				JOptionPane.showMessageDialog
					(this,"Error Connect Source","Error loading file",JOptionPane.ERROR_MESSAGE);
			else
				JOptionPane.showMessageDialog
					(this,"Invalid file or location","Error loading file",JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	 *   Remove component & stop player & drop all resouce used by player
	 *   Stop player and Release it's memory location ( for using of control track and datasource )
	 */
    public void stopPlayer ()
    {
		Component jmpcomp ;

		player.stop();
		player.deallocate();

		if ((jmpcomp = player.getControlPanelComponent()) != null)
			southBorder.remove ( jmpcomp );
		if ((jmpcomp = player.getVisualComponent()) != null)
			southBorder.remove ( jmpcomp );
		//validate();
	}

	/**
	 *   Player controller for control : error ; component init ; End of Media
	 *   Handle create component of default track's controller
	 *   Handle while end of track
	 */
	private class playerController implements ControllerListener
	{
	    public void controllerUpdate (ControllerEvent event)
		{
			Component jmpcomp ;
            float volume = (float) ( ( (volumeSlider.getValue()) / 100.0 ) );
			// initial Control Component
			if (event instanceof RealizeCompleteEvent)
		    {
				if ( player.getGainControl() != null )
					player.getGainControl().setLevel ( volume );
				if ((jmpcomp = player.getVisualComponent()) != null)
					southBorder.add ( "Center" , jmpcomp);
				if ((jmpcomp = player.getControlPanelComponent()) != null)
					southBorder.add ( "South" , jmpcomp );

				validate();
			}
			// control when End of Media <Loop or Somthing...>
			if ( event instanceof EndOfMediaEvent )
			{
				if ( setLoop != 3 )
				    dealTrack ( playHistory.getSelectedIndex() ) ;
			}
		}
	}

	/**
	 *   player controller speciallized for URL player (differ in EofM & error control)
	 */
	private class playURLController implements ControllerListener
	{
		public void controllerUpdate ( ControllerEvent event )
		{
			Component jmpcomp ;
			float volume = (float) ( ( (volumeSlider.getValue()) / 100.0 ) );
			// initial Control Component
			if (event instanceof RealizeCompleteEvent)
			{
				if ( player.getGainControl() != null )
					player.getGainControl().setLevel ( volume );
				if ((jmpcomp = player.getControlPanelComponent()) != null)
					southBorder.add ( "South" , jmpcomp );

				validate();
			}
			// control when End of Media < close >
			if ( event instanceof EndOfMediaEvent )
			{
				stopPlayer();
				player = null ;
				if ( setLoop != 3)
					dealTrack ( playHistory.getSelectedIndex() );
			}
			// control unrecoverable ERROR
			if ( event instanceof ControllerErrorEvent )
			{
				JOptionPane.showMessageDialog
					( null ,"No Recovery Mechanism \nPlayer Abort","Error Occur",JOptionPane.ERROR_MESSAGE);
				stopPlayer();
			}
		}
	}

}